#! /usr/bin/env python

import os, sys
import pygame
import level001
import basicSprite
import movingSprite
from pygame.locals import *
from helpers import *
from bunnySprite import *


if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'

BLOCK_SIZE = 24

class BunnyRun:
	"""Bunny run a game of running bunnies"""

	def __init__(self, width=640,height=480):
		"""Initialize"""
		"""Initialize PyGame"""
		pygame.init()
		"""Set the window Size"""
		self.width = width
		self.height = height
		"""Create the Screen"""
		self.screen = pygame.display.set_mode((self.width, self.height))
		# Init the veggies eaten
		self.vegetables_eaten = 0
		# Game Rect
		self.game_rect = pygame.Rect(0,0,0,0)


	def MainLoop(self):
		"""This is the Main Loop of the Game"""

		"""Load All of our Sprites"""
		self.LoadSprites();

		"""Create the background"""
		self.background = pygame.Surface(self.screen.get_size())
		self.background = self.background.convert()
		self.background.fill((124,124,124))
		pygame.display.update()
		"""Draw the blocks onto the background, since they only need to be
		drawn once"""
		self.background_sprites.draw(self.background)
		self.block_sprites.draw(self.screen)
		self.block_sprites.draw(self.background)

		self.screen.blit(self.background, (0, 0))

		#self.pellet_sprites.draw(self.screen)
		#self.pellet_sprites.draw(self.background)

		pygame.display.flip()
		while 1:

			self.bunny_sprites.clear(self.screen,self.background)

			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == KEYDOWN:
					if ((event.key == K_RIGHT)
					or (event.key == K_LEFT)
					or (event.key == K_UP)
					or (event.key == K_DOWN)):
						self.bunny.MoveKeyDown(event.key)
				elif event.type == KEYUP:
					if ((event.key == K_RIGHT)
					or (event.key == K_LEFT)
					or (event.key == K_UP)
					or (event.key == K_DOWN)):
						self.bunny.MoveKeyUp(event.key)
				elif event.type == MOUSEMOTION:
					self.cursor_sprite.rect = self.get_mouse_block_rect()
				elif event.type == MOUSEBUTTONDOWN:
					self.on_mouse_button_down(event)
				elif (event.type == RABBIT_EATING_OVER):
					self.vegetables_eaten += 1


			"""Update the snake sprite"""
			self.dog_sprites.update(pygame.time.get_ticks()
										, self.block_sprites)

			self.bunny_sprites.update(pygame.time.get_ticks()
										, self.block_sprites
										, self.hole_in_sprites
										, self.hole_out_rect
										, self.carrot_sprites)





			"""Do the Drawging"""
			title_text = 0
			veggie_text = 0
			self.screen.blit(self.background, (0, 0))
			if pygame.font:
				# Title, should only be done onece
				font = pygame.font.Font(None, 36)
				text = font.render("Bunny Run!", 1, (147, 1, 16))
				title_text = text.get_rect(centerx=self.background.get_width()/2)
				self.screen.blit(text, title_text)
				# Veggie stats
				font = pygame.font.Font(None, 36)
				text = font.render("Veggies Eaten: %02d" % self.vegetables_eaten, 1, (147, 1, 16))
				veggie_text = text.get_rect(right=self.background.get_width() - 24)
				self.screen.blit(text, veggie_text)

			reclist = [title_text, veggie_text]
			reclist += self.hole_in_sprites.draw(self.screen)
			reclist += self.hole_out_sprites.draw(self.screen)
			reclist += self.carrot_sprites.draw(self.screen)
			reclist += self.dog_sprites.draw(self.screen)
			reclist += self.bunny_sprites.draw(self.screen)
			reclist += self.cursor_sprites.draw(self.screen)
			#reclist += (self.block_sprites.draw(self.screen))

			pygame.display.update(reclist)
			# pygame.display.flip()

	def LoadSprites(self):
		"""Load all of the sprites that we need"""
		"""calculate the center point offset"""
		x_offset = (BLOCK_SIZE/2)
		y_offset = (BLOCK_SIZE/2)
		"""Load the level"""
		level1 = level001.level()
		if (not level1.load_level()):
			print "could not load level"
			return


		"""Create the Group"""
		self.block_sprites = pygame.sprite.RenderUpdates()
		self.background_sprites = pygame.sprite.RenderUpdates()
		self.carrot_sprites = pygame.sprite.RenderUpdates()
		self.bunny_sprites = pygame.sprite.RenderUpdates()
		self.dog_sprites = pygame.sprite.RenderUpdates()

		# Create Image lists
		block_list = ['block.png', 'fence_vert.png', 'fence_horiz.png'
			, 'fence_corner_tl.png', 'fence_corner_tr.png', 'fence_corner_br.png'
			, 'fence_corner_bl.png']
		carrot_list = ['carrot_03.png']
		background_list = ['grass_01.png']
		bunny_list = ['bunny_01.png', 'bunny_03.png', 'bunny_02.png']
		dog_list = ['dog_01.png']


		# Now we need to load the fle
		rect = pygame.Rect((0,0),(BLOCK_SIZE,BLOCK_SIZE))
		x = 0;
		y = 0;
		for row in level1.level_list:
			for item_list in row:
				rect.left = x * BLOCK_SIZE
				rect.top = y * BLOCK_SIZE
				for tile in item_list:
					image = level1.get_image(tile)
					if (tile in block_list):
						self.block_sprites.add(basicSprite.Sprite(rect.center, image))
					elif (tile in carrot_list):
						self.carrot_sprites.add(basicSprite.Sprite(rect.center, image))
					elif (tile in background_list):
						self.background_sprites.add(basicSprite.Sprite(rect.center, image))
					elif (tile in bunny_list):
						self.bunny_sprites.add(Bunny(rect.center,level1.get_bunny_sprites()))
					elif (tile in dog_list):
						self.dog_sprites.add(
							movingSprite.Sprite(rect.center,[image], 100, 6))

				x += 1
			y += 1
			x = 0


		# Cursor block highlight
		cursor_image, rect = load_image("cursor_rect.png",(255, 0, 255, 255))
		self.cursor_sprite = basicSprite.Sprite(((BLOCK_SIZE/2),(BLOCK_SIZE/2))
										, cursor_image)
		self.cursor_sprites = pygame.sprite.RenderUpdates(self.cursor_sprite)

		self.hole_in_sprites = pygame.sprite.RenderUpdates();
		self.hole_out_sprites = pygame.sprite.RenderUpdates();
		# Init the hole out sprite
		self.hole_out_sprite = None
		self.hole_out_rect = None
		# Init the hole in sprites
		self.hole_in_image, rect = load_image("hole_in.png", -1)
		self.hole_out_image, rect = load_image("hole_out.png", -1)

		self.game_rect = level1.get_game_rect()

	def get_mouse_block_rect(self):
		"""This function is to get the block rectangle
		associated with the current mouse position"""

		x_pos, y_pos = pygame.mouse.get_pos()
		x_pos = ((x_pos / BLOCK_SIZE)) * BLOCK_SIZE
		y_pos = ((y_pos / BLOCK_SIZE)) * BLOCK_SIZE

		return pygame.Rect((x_pos, y_pos), (BLOCK_SIZE,BLOCK_SIZE))

	def on_mouse_button_down(self, event):
		"""Called when the event loop gets a mouse down event
		@parm event - pygame.event.Event - MOUSEBUTTONDOWN  pos, button
		"""

		if (self.is_rect_safe_for_hole(self.cursor_sprite.rect)):
			# Add a hole down
			if pygame.key.get_mods() & KMOD_CTRL:
				if (self.hole_out_sprite):
					self.hole_out_rect = self.hole_out_sprite.rect = self.cursor_sprite.rect
				else:
					self.hole_out_sprite = basicSprite.Sprite(self.cursor_sprite.rect.center
						, self.hole_out_image)
					self.hole_out_sprites.add(self.hole_out_sprite)
					self.hole_out_rect = self.cursor_sprite.rect
			else:
				self.hole_in_sprites.add(basicSprite.Sprite(self.cursor_sprite.rect.center
					, self.hole_in_image))

	def is_rect_safe_for_hole(self, rect):
		"""This fucntion texts to make sure that the current rect is
		safe for a hole to be placed there.  For the rect to be safe it must
		be within the game rect, not on a block, and not on any other
		hole...
		@rect - pygame.Rect() - The rect to test
		"""

		safe = False

		if (self.game_rect.contains(rect)):
			# The rect must be within the game rect
			# Create a dummy sprite to check for collisions
			dummy = pygame.sprite.Sprite()
			dummy.rect = rect;
			if ((not pygame.sprite.spritecollideany(dummy, self.hole_in_sprites))
				and (not pygame.sprite.spritecollideany(dummy, self.hole_out_sprites))
				and (not pygame.sprite.spritecollideany(dummy, self.block_sprites))
				and (not pygame.sprite.spritecollideany(dummy, self.carrot_sprites))):

				safe = True
		return safe



if __name__ == "__main__":
    MainWindow = BunnyRun(800,600)
    MainWindow.MainLoop()
