#! /usr/bin/env python
import pygame
import levelBase
from helpers import load_image
import cPickle


class level(levelBase.Level):
	"""Level 1 of the PyMan Game"""

	def __init__(self):
		self.image_dict = None
		self.level_list = None

		bunny_01, rect = load_image('bunny_01.png',-1)
		bunny_02, rect = load_image('bunny_02.png',-1)
		bunny_03, rect = load_image('bunny_03.png',-1)

		self.bunny_sprites = [bunny_01, bunny_02, bunny_03, bunny_02]

	def load_level(self):
		"""Load your level file and fill the internal structures"""

		# Load from file
		try:
			file = open("level_001.sle", 'rb')
			self.image_dict = cPickle.load(file)
			self.level_list = cPickle.load(file)
			file.close()
		except:
			#failed just get outta here maybe the file doesn't exist
			print "Failed to open file"
			return False

		# Now we need to populate the dictionary with the right image

		for image_name in self.image_dict.keys():
			# Load the image
			color_key = -1
			if (image_name == "grass_01.png"):
				color_key = (255, 0, 255, 255)
			image, rect = load_image(image_name, color_key)
			self.image_dict[image_name] = image

		return True

	def getLayout(self):
		return self.level_list


	def get_bunny_sprites(self):
		return self.bunny_sprites

	def get_game_rect(self):
		return pygame.Rect((24, 72), (744, 528))
